package cn.com.infosec.mobile.android.algorithm;

import android.util.Base64;
import android.util.SparseArray;
import cn.com.infosec.mobile.android.framework.crypto.impl.gm.SM2Impl;
import java.io.IOException;

public class SM2 {
   public SparseArray<byte[]> genKeyPair(String seed) {
      return this.genKeyPair();
   }

   public SparseArray<byte[]> genKeyPair() {
      byte[] var2 = new byte[65];
      byte[] var1;
      SM2Impl.genKeyPair(var1 = new byte[32], var2);
      SparseArray var10000 = new SparseArray(2);
      var10000.put(0, var1);
      var10000.put(1, var2);
      return var10000;
   }

   public byte[] encrypt(byte[] plain, byte[] pubKey) {
      return plain != null && plain.length > 0 && pubKey != null && pubKey.length == 65 ? SM2Impl.encrypt(plain, pubKey) : null;
   }

   public byte[] encryptWithoutASN(byte[] plain, byte[] pubKey) {
      return plain != null && plain.length > 0 && pubKey != null && pubKey.length == 65 ? SM2Impl.encryptWithoutASN(plain, pubKey) : null;
   }

   public byte[] decrypt(byte[] cipher, byte[] priKey) {
      return cipher != null && cipher.length > 0 && priKey != null && priKey.length == 32 ? SM2Impl.decrypt(cipher, priKey) : null;
   }

   public byte[] decryptWithoutASN(byte[] cipher, byte[] priKey) {
      return cipher != null && cipher.length > 0 && priKey != null && priKey.length == 32 ? SM2Impl.decryptWithoutASN(cipher, priKey) : null;
   }

   public String encode(byte[] publicKey, byte[] plainTxt, boolean ans1) {
      IOException var10000;
      label26: {
         boolean var10001;
         byte[] var8;
         if (ans1) {
            try {
               var8 = this.encrypt(plainTxt, publicKey);
            } catch (IOException var6) {
               var10000 = var6;
               var10001 = false;
               break label26;
            }
         } else {
            try {
               var8 = this.encryptWithoutASN(plainTxt, publicKey);
            } catch (IOException var5) {
               var10000 = var5;
               var10001 = false;
               break label26;
            }
         }

         byte[] var7 = var8;

         try {
            return Base64.encodeToString(var7, 2);
         } catch (IOException var4) {
            var10000 = var4;
            var10001 = false;
         }
      }

      var10000.printStackTrace();
      return null;
   }

   public String decode(byte[] privateKey, byte[] encodeData) {
      try {
         return Base64.encodeToString(this.decryptWithoutASN(encodeData, privateKey), 2);
      } catch (IOException var3) {
         var3.printStackTrace();
         return null;
      }
   }
}
